/*******************************************************************************
*               Copyright (c) Gemplus Card International 1997
*
* Name        : bin2c.c
*
* Description : 

  Author      : JL GIRAUD
  Compiler    : Visual C++, GNU gcc compiler
  Host        : Windows 9x,NT, Linux
*
* $Id: bin2c.c,v 1.2 2000/09/04 08:19:06 rousseau Exp $
* $Log: bin2c.c,v $
* Revision 1.2  2000/09/04 08:19:06  rousseau
* code cleanup, changed the API and name for [Init|Close]Serial
*
*
********************************************************************************
*
* Warning     : 
*
* Remarks     : 
*
*******************************************************************************/


/* Transforms int value in a length char array   */
void bin2c(int value, char* buffer, int length)
{
	int i;
	int nibble;

	for (i = 0; i < length; i++)
	{
		nibble = value - (value >> 4 <<4);
		if (nibble < 10)
		{
			buffer[length-1-i] = nibble + '0';
		}
		else
		{
			buffer[length-1-i] = nibble -10 + 'A';
		}
		value >>= 4;
	}
}
